

%
% class TDL: Tapped Delay Line
%

%
% This function returns new a gainv value for each tap in the TDL.
%

function [c, g] = getNewGainValues( c )

% refill the buffers if they are empty
if c.gainBufferIndex > c.blockSize
    
    % generate one block for each tap and save in buffer
    for i=[1:c.numTaps]
       [c.taps( i ).gen, c.taps( i ).buffer] = generate( c.taps( i ).gen, c.blockNum );
    end;
    
    c.blockNum = c.blockNum + 1;
    c.gainBufferIndex = 1;
    
end;

% get the gain value for each tap from the buffer for that tap
for i=[1:c.numTaps]
    
    g(i) = c.taps( i ).buffer( c.gainBufferIndex ) * ...
            c.powerDelayProfile( i );
    
end;

% point the index to the next gain sample in the buffer
c.gainBufferIndex = c.gainBufferIndex + 1;
