

%
% class TDL: Tapped Delay Line
%

%
% process, simulates the effects of fading on the input vector 
% containing signal samples.
%

function [c, y] = process( c, s )

% length of input vector
iLength = length( s );

for i = [1:iLength]
    
    % shift everything to right
    c.buffer = circshift( c.buffer, [0, 1] );
    
    % put new value in
    c.buffer(1) =  s(i);
    
    % get new gain values
    [c g] = getNewGainValues( c );
    
    % multiply out the numbers    
    y(i) = sum( c.buffer .* g );
    
end;

