
%
% createUncorGenerators: creates an array of uncorrelated generators
% based on a sample generator passed in.
%

function a = createUncorGenerators( n, sampleGen, threshold )

% get the handle of the constructor of the generator
consFunc = str2func(class( sampleGen ));

% create n generators
for i=1:n
    
    % Repeat until we have created a generator that is uncorrlated
    % to all other generators
    correlated = 1;
    while correlated
        
        % create an new generator
        a( i ) = feval( consFunc, sampleGen );

        % check to see if it is correlated to the previous ones we created
        correlated = 0;
        for j=1:i-1
            if isCorrelated( a(i), a(j), threshold )
                correlated = 1;
                break;
            end;
        end;
    end;
    
end;